//////////////////////////////////////////////////////////////////////
//
// Program Name : Wrap
// Author       : Philip Wilk
//
// Purpose      : Takes standard input (up to 4K lines) and outputs
//              : the input with word wrapping. Useful in pipes.
//
// Distrubution : This program is FreeWare covered by the Gnu license.
//              : Blah blah blah, play nice and don't run with sissors.
//
//  VERSION     DATE        DESC
//  1.0.0       05/05/96    Birthday.
//
//////////////////////////////////////////////////////////////////////


#include <iostream.h>
#include <strstream.h>
#include "strings.h"        // my string handler

int main() {
   char * yuckyLine;        // i hate C style strings
   String line, word;
   int length = 0;
   while ( getline(cin, line) ) {         // Gawddamn Borland C will
      yuckyLine = line.chars();           // not use my String type
      istrstream inputBuffer(yuckyLine);  // coverter properly.
      while (inputBuffer >> word) {
         if ( (length + word.length() ) > 78) {
            cout << endl;
            length = 0;
         }
         cout << word << " ";
         length += word.length();
         length += 1;                     // watch that space!
      }
      cout << endl;
      length = 0;
   }
   return 0;                              // success!
}
